/* Copyright 2023 Kevin Ryde

   This file is part of pari-primecount.

   pari-primecount is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 3, or (at your option) any later
   version.

   pari-primecount is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
   or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.

   You should have received a copy of the GNU General Public License along
   with pari-primecount.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "../pari_primecount.c"

#define numberof(array)  (sizeof(array)/sizeof((array)[0]))

GEN
try_gen_to_int64_positive(void)
{
  static struct {
    const char * const str;
    int64_t want;
  } data[] = {
    { "2^63-1", INT64_MAX },
    { "2^32-1", UINT32_MAX },
    { "2^31-1", INT32_MAX },
    { "2^32 + 3", ((int64_t) 1 << 32) + 3 },
    { "1", 1 },
    { "0", 0 },
    { "gen_0", 0 },
  };

  printf("try_gen_to_int64_positive\n");
  int i;
  for (i=0; i < numberof(data); i++) {
    printf("%s\n", data[i].str);
    GEN g = (strcmp(data[i].str,"gen_0")==0 ? gen_0
             : gp_read_str(data[i].str));
    int64_t got = gen_to_int64_positive(g);
    if (got != data[i].want) {
      printf("oops got %"PRId64" want %"PRId64"\n",
             got, data[i].want);
      exit(1);
    }
  }
  return (gen_1);
}
